'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _desc, _value, _class, _descriptor;

var _mobx = require('mobx');

var _ramda = require('ramda');

var _ramda2 = _interopRequireDefault(_ramda);

var _FieldStore = require('./FieldStore');

var _FieldStore2 = _interopRequireDefault(_FieldStore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var FormStore = (_class = function () {
  function FormStore() {
    _classCallCheck(this, FormStore);

    _initDefineProp(this, 'fields', _descriptor, this);
  }

  _createClass(FormStore, [{
    key: 'addField',


    /**
     * @protected
     * @param name: string - name of the field
     */
    value: function addField(name) {
      if (!this.fields[name]) {
        this.fields[name] = new _FieldStore2.default();
      }
    }

    /**
     * @protected
     * @param name: string - name of the field
     */

  }, {
    key: 'removeField',
    value: function removeField(name) {
      delete this.fields[name];
    }
  }, {
    key: 'values',
    get: function get() {
      return _ramda2.default.map(_ramda2.default.prop('value'), this.fields);
    }
  }, {
    key: 'errors',
    get: function get() {
      return _ramda2.default.map(_ramda2.default.prop('error'), this.fields);
    }
  }]);

  return FormStore;
}(), (_descriptor = _applyDecoratedDescriptor(_class.prototype, 'fields', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return {};
  }
}), _applyDecoratedDescriptor(_class.prototype, 'values', [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, 'values'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'errors', [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, 'errors'), _class.prototype)), _class);
exports.default = FormStore;